﻿using System;
using System.Diagnostics;
using System.IO;
using System.Text;
using Syncfusion.XlsIO;
using System.Windows.Forms;

namespace ExtractPDFTabularData
{
    public partial class Form1 : Form
    {
        string dataPath = "";
        public Form1()
        {
            InitializeComponent();
        }
     
        private void Form1_Load(object sender, EventArgs e)
        {
            SetDataPath();
        }       

        private void SetDataPath()
        {   
            string[] words = Application.StartupPath.Split(new string[] { "\\" }, StringSplitOptions.None);
            for (int i = 0; i < words.Length - 2; i++)
                dataPath += (words[i]+@"\");
            dataPath+=("Data");
        }

        private void Extract_Click(object sender, EventArgs e)
        {
            ProcessStartInfo startInfo = new ProcessStartInfo(@"C:\Program Files\Java\jre1.8.0_161\bin\java.exe");
            startInfo.WindowStyle = ProcessWindowStyle.Hidden;
            startInfo.WorkingDirectory = dataPath;
            startInfo.Arguments = "-jar tabula-0.8.0-jar-with-dependencies.jar -p all -o K2019HU3000KDX000296.csv K2019HU3000KDX000296.pdf";
            Process currentProcess=Process.Start(startInfo);
            currentProcess.WaitForExit();

            string[] files = Directory.GetFiles(dataPath, "*.csv");
            ExtractPDFTabularData(files[0]);

            MessageBox.Show("Extraction of PDF tabular data processed successfully.... \n Output file is stored in the Output Folder");
        }

        private void ExtractPDFTabularData(string filePath)
        {
            ExcelEngine excelEngine = new ExcelEngine();
            IApplication application = excelEngine.Excel; 
            IWorkbook workbook = application.Workbooks.Open(filePath);
            IWorksheet sheet = workbook.Worksheets[0];

            StringBuilder tabularData= new StringBuilder();

            for(int i=1;i<=sheet.Rows.Length;i++)
            {
                for(int j=1;j<=sheet.Columns.Length;j++)
                {
                    tabularData.Append(sheet.GetText(i, j));
                    tabularData.Append("\t");
                }
                tabularData.Append("\n");
            }

            File.WriteAllText(@"../../Output/output.txt", tabularData.ToString());
            workbook.Close();
            excelEngine.Dispose();            
        }
    }
}
